{
 Timer for MSX Mines - From original time.inc
 Original code: SLotman : http://www.icongames.com/msx
 Modified by: Marcelo Teixeira Silveira
 http://www.eng,uerj.br/~marcelo/msx
}


{
Function   GetTime:TimeStrType;
   - pure mc
   - uses DOS function #2c ( _GTIME )
   - returns string in format hh:mm:ss
   - reads the clock chip
}

Var hi,mi,si,hc,mc,sc : byte;

Procedure GetTime(mode : integer);
  Var hora, min, seg: byte;
   Begin
      Inline (
         $f3/        { DI }

         $0E/$2C/        { LD C, 2Ch  - get time                    }
         $CD/$05/$00/{ CALL F37Dh - mesmo que call 0005 do dos1 }

         $7C/        { LD A,H }
         $32/hora/   { LD (hora),A }
         $7D/        { LD A,L }
         $32/min/    { LD (min),A }
         $7A/        { LD A,D }
         $32/seg/    { LD (seg),A }
         $fb         { EI }
         );
                                
         if (mode=0) then
         begin
            hi:=hora;
            mi:=min;
            si:=seg;
         end;
         hc:=hora;
         mc:=min;
         sc:=seg;
End;


procedure start_timer;
begin
  GetTime(0);
end;

{ return elapsed seconds }
function elapsed_time : integer;
const hstep : integer = 3600;
      mstep : integer = 60;
      sstep : integer = 1;
var   dh, dm, ds, i, f : integer;
begin
  GetTime(1);
  
  { Seconds }
  ds:=0;
  if (sc>=si) then
  begin
    f:=sc-si;
    for i:=1 to f do
      ds:=ds+sstep;
  end
  else
  begin
    f:=si-sc;
    for i:=1 to f do
      ds:=ds-sstep;
  end;

  { Minutes }
  dm:=0;
  if (mc>=mi) then
  begin
    f:=mc-mi;
    for i:=1 to f do
      dm:=dm+mstep;
  end
  else
  begin
    f:=mi-mc;
    for i:=1 to f do
      dm:=dm-mstep;
  end;

  { Hours }
  if (hc=0) and (hi<>0) then hc:=hi+1; { Check for next day }
  f:=hc-hi;
  dh:=0;
  for i:=1 to f do
    dh:=dh+hstep;

  elapsed_time:=dh+dm+ds;
end;