{
  MSX Minesweeper
  ==============================================
  (2006) MarMSX
  Programmed by Marcelo Silveira
  http://www.eng.uerj.br/~marcelo/msx

}


{ Global variables }
var width, height, mines, flags : integer;
	mineMap : array[1..30,1..16] of integer;
	flagMap : array[1..30,1..16] of boolean;
	clickMap : array[1..30,1..16] of boolean;


procedure chooseGame(game : integer);
begin
	case game of
	1 : begin
			width:=30;
			height:=16;
			mines:=99;
		end;
	end;
end;

procedure resetMap;
var	i,j : integer;
begin
	for i:=1 to width do
	begin
		for j:=1 to height do
		begin
			mineMap[i,j]:=0;
			flagMap[i,j]:=false;
			clickMap[i,j]:=false;
		end;
	end;
end;

procedure printMap;
var i,j : integer;
begin	
	for j:=1 to height do
	begin
		for i:=1 to width do
		begin
			if mineMap[i,j]=-1 then
				write('*')
			else
				write(mineMap[i,j])
		end;
		writeln;
	end;
end;

procedure notifyBomb(x,y : integer);
var i,j : integer;
begin	
	for i:=x-1 to x+1 do
	begin
		for j:=y-1 to y+1 do
		begin
			if ((mineMap[i,j]<>-1) and (i>=1) and (j>=1) and (i<=width) and (j<=height)) then
				mineMap[i,j]:=mineMap[i,j]+1;
		end;
	end;
end;

function winGame : boolean;
var i, j : integer;
begin       
  winGame:=true;
  for i:=1 to width do
  begin
    for j:=1 to height do
    begin
      if (mineMap[i,j]<>-1) then { Only check for non bomb places }
      begin
        if (clickMap[i,j]=false) then { If it finds at least one uncouverd place, not win }
        begin
          winGame:=false;
          exit;
        end;
      end;
    end;
  end;
end;

function randomTime(num : integer) : integer;
var  seed, max : integer;
Begin
    randomize;    

    max:=199;
    seed:=random(200);
    seed:=(seed*num) div max;
    
    randomTime:= abs(seed);
end;

procedure createMap;
var rand_i,rand_j,i : integer;
begin	
	for i:=1 to mines do
	begin
		repeat
			rand_i:=randomTime(width)+1;
			rand_j:=randomTime(height)+1;
		until mineMap[rand_i,rand_j]<>-1;
		mineMap[rand_i,rand_j]:=-1;
		notifyBomb(rand_i,rand_j);
	end;
end;