{
  MSX Super Minesweeper - Challange!
  ==============================================
  (2006) MarMSX
  Programmed by Marcelo Silveira
  http://www.eng.uerj.br/~marcelo/msx

}
{$A-}
{$K+}
{$i MsxDskIO.inc}
{$i msx.inc }
{$i misc.inc}
{$i minetime.inc}
{$i spmap.pas}
{$i ranking.pas}
                                                         
{ 

Objects coordinates

}                                  
const scrCoord : array[-1..18,1..4] of integer = 	((12,0,23,11),
													(0,12,11,23),
													(12,12,23,23),
													(24,12,35,23),
 													(36,12,47,23),
 													(48,12,59,23),
 													(60,12,71,23),
 													(72,12,83,23),
 													(84,12,95,23),
 													(96,12,107,23),
 													(0,0,11,11),
	 												(24,0,35,11),
 													(36,0,47,11),
 													(48,0,59,11),
	 												(0,24,359,42),
 													(0,43,191,61),
 													(172,25,190,41),
 													(108,0,124,16),
 													(124,0,141,16),
 													(60,0,71,11));
 												 												
{
-1	Bomba				12	0	23	11
0	Caixa Baixa Vazia	0	12	11	23
1	1 mina				12	12	23	23
2	2 mina				24	12	35	23
3	3 mina				36	12	47	23
4	4 mina				48	12	59	23
5	5 mina				60	12	71	23
6	6 mina				72	12	83	23
7	7 mina				84	12	95	23
8	8 mina				96	12	107	23
9	Caixa Alta Vazia	0	0	11	11
10	Bomba Vermelha		24	0	35	11
11	Bandeira Errada		36	0	47	11
12	Bandeira			48	0	59	11
13	Moldura para easy	0	24	95	42
14	Moldura para hard	0	43	191	61
15	Sorriso				40	25	56	41
16	Perdeu				108	0	124	16
17	Ganhou				125	0	141	16
18	Bandeira errada		60	0	71	11
}
	gameAlign : array[1..2,1..2] of integer = ((60,1),(0,0));
	

var gameType : integer;
	cursorX, cursorY : integer;
	theEnd : boolean;
	timeStart : boolean;
	recordChanged : boolean;	
	{tirar isto!}
	teste : boolean;
	l,m : integer;
	plytime : integer;
	plyname : string[12];

procedure rankDialog;
var c : char;
    i, j, xi, yi, xf, yf : integer;
begin
  c:='a';
  xi:=90;
  yi:=90;
  xf:=xi+85;
  yf:=yi+30;
  
  { Save screen under menu }
  Copy(xi,yi,xf,yf,0,0,150,1);
  
  Color(15,4,0);
  line_bf(xi,yi,xf,yf,4,0);
  line_b(xi,yi,xf,yf,15,0);
  Print(xi+5,yi+5,15,'New record!');
  Color(15,0,0);
  Print(xi+5,yi+20,15,'            ');
  if (Length(plyName)>0) then
    Print(xi+5,yi+20,15,plyName);
  
  i:=length(plyName);
  if i=0 then i:=1;
  c:='a';
  while ord(c)<>13 do
  begin
    read(kbd,c);
    if ord(c)= 8 then
    begin
      i:=i-1;      
      if (i<1) then 
      begin
        i:=1;
        plyName:='';
      end  
      else                                  
        plyName:=Copy(plyName,1,i-1);
      Print(xi+5+(i-1)*6,yi+20,15,' ');  
    end;
    if (ord(c)>=32) and (ord(c)<=127) then
    begin    
      i:=i+1;
      if (i>12) then
      begin
        i:=12;
        plyName:=Copy(plyName,1,11)+c;
      end
      else
        plyName:=plyName+c;
      Print(xi+5,yi+20,15,plyName);
    end;
  end;
  
  Copy(0,150,xf-xi,150+yf-yi,1,xi,yi,0);
  insertNew(plyName,plytime,gameType);
  recordChanged:=true;
end;

procedure mountTable;
var i,j, page : integer;
	offsetX, offsetY : integer;
begin
    {Copy(X1,Y1,X2,Y2,SrcPage,DestX,DestY,DestPage:integer);}
    {line_bf(x,y,x2,y2:integer;kleur,log_op:byte);}
    
    page:=0;
    
    { Header }
    Copy(scrCoord[12+gameType,1],scrCoord[12+gameType,2],
    scrCoord[12+gameType,3],scrCoord[12+gameType,4],
    1,
    gameAlign[gameType,1],gameAlign[gameType,2],
    page);    
    { Matrix }    
    offsetY:=scrCoord[12+gameType,4]-scrCoord[12+gameType,2]+gameAlign[gameType,2]+1;
    for i:=1 to height do
    begin
      offsetX:=gameAlign[gameType,1];
      for j:=1 to width do 
      begin
      	Copy(scrCoord[9,1],scrCoord[9,2],
         scrCoord[9,3],scrCoord[9,4],
        1,
        offsetX,offsetY,
        page);
        offsetX:=offsetX+12; 
      end;
      offsetY:=offsetY+12;      
    end;
end;

procedure displayMap;
var i,j, page : integer;
	offsetX, offsetY : integer;
begin
    page:=0;
    
    { Matrix }    
    offsetY:=scrCoord[12+gameType,4]-scrCoord[12+gameType,2]+gameAlign[gameType,2]+1;
    for i:=1 to width do
    begin
      offsetX:=gameAlign[gameType,1];
      for j:=1 to height do 
      begin
      	Copy(scrCoord[mineMap[i,j],1],scrCoord[mineMap[i,j],2],
        scrCoord[mineMap[i,j],3],scrCoord[mineMap[i,j],4],
        1,
        offsetX,offsetY,
        page); 
        offsetX:=offsetX+12; 
      end;
      offsetY:=offsetY+12;      
    end
end;

procedure revealBombs;
var i,j, page, obj : integer;
	offsetX, offsetY : integer;
begin
    page:=0;
    
    { Matrix }    
    offsetY:=scrCoord[12+gameType,4]-scrCoord[12+gameType,2]+gameAlign[gameType,2]+1;
    for j:=1 to height do
    begin
      offsetX:=gameAlign[gameType,1];
      for i:=1 to width do 
      begin
        if (mineMap[i,j]=-1) and (flagMap[i,j]=false) then { Keep correct flags on }
        begin
        	if (cursorX=i) and (CursorY=j) then
        	  obj:=10
        	else
        	  obj:=-1;
      		Copy(scrCoord[obj,1],scrCoord[obj,2],
          	scrCoord[obj,3],scrCoord[obj,4],
          	1,
          	offsetX,offsetY,
            page);        	    
        end;
        if (mineMap[i,j]<>-1) and (flagMap[i,j]=true) then
        begin
          obj:=11;
          Copy(scrCoord[obj,1],scrCoord[obj,2],
        	scrCoord[obj,3],scrCoord[obj,4],
          	1,
          	offsetX,offsetY,
           page); 
        end;  
        offsetX:=offsetX+12; 
      end;
      offsetY:=offsetY+12;      
    end;
end;

procedure openNode(i,j : integer);
var offsetX, offsetY,page : integer;
begin
  { Separated to make flood_fill piles lighter }
  clickMap[i,j]:=true;
  flagMap[i,j]:=false;
  page:=0;
  offsetX:=gameAlign[gameType,1]+(i-1)*12;
  offsetY:=(scrCoord[12+gameType,4]-scrCoord[12+gameType,2]+gameAlign[gameType,2]+1)+(j-1)*12;
  Copy(scrCoord[mineMap[i,j],1],scrCoord[mineMap[i,j],2],
		scrCoord[mineMap[i,j],3],scrCoord[mineMap[i,j],4],
      	1,
       	offsetX,offsetY,
       	page);        	
end;

procedure flood_fill(i,j : integer);
var x,y : integer;
begin
    {If out of bounds, return}
    if (i<1) or (j<1) or (i>width) or (j>height) then
      exit;

    {If node is already visited, return}
    if (clickMap[i,j]=true) then
      exit;

    {Open node}
    openNode(i,j);

    {If node <> empty, return}
    if (mineMap[i,j]<>0) then
      exit;
    
    {Spread this to its 8 neighbors}
    for x:=-1 to 1 do
    begin
        for y:=-1 to 1 do
        begin
                if not((x=0) and (y=0)) then
                        flood_fill(i+x,j+y);
        end;
    end;
end;
      
procedure loadScreen;
begin
  	{load image}
	screen(7);
	Color(15,0,0);
	Print(170,105,15,'MarMSX - loading Super Mines ...');
	Print(0,170,15,'Powered by:');
	Print(0,180,10,'MSX Viewer - MarMSX');
	Print(0,190,10,'MSXPad - The MSX Files');
	{ Page 1 for images } 
	{LoadGraphic(FileName :StringType; Width, Height: Integer; x,y:Integer; Page:Byte;LogOp, ScrMod :Byte);}
	LoadGraphic('BACK7.IMG',512,212,0,0,1,0,7);
	cls2;
end;

procedure printLabels;
var i, j : integer;
	w : string[10];
begin 
  {SetPage(DisplayPage,ActivePage:Byte);}
  { Use double buffer to eliminate flick }
  SetPage(0,1);
  { For # of flags }
  i:=gameAlign[gameType,1]+14;
  j:=gameAlign[gameType,2]+7;
  str(flags,w);
  w:='0'+w;
  w:=Copy(w,Length(w)-1,2);
  Print(i,j,6,w);
  Copy(i,j,i+12,j+7,1,i,j,0); { Copy back page 0 }  
  { For time }
  i:=gameAlign[gameType,1]+scrCoord[12+gameType,3]-39;
  w:='0000';
  if (timeStart=true) then
  begin
    plytime:=elapsed_time;
    if plytime>9999 then plytime:=9999;
    str(plytime,w);
    w:='000'+w;
    w:=Copy(w,Length(w)-3,4);
  end;
  Print(i,j,6,w);
  Copy(i,j,i+24,j+7,1,i,j,0); { Copy back to page 0 }
  SetPage(0,0);  
end;

function checkPlace(i,j : integer) : boolean;
begin
  if mineMap[i,j]=-1 then
    checkPlace:=false;
end;

procedure recoverObject;
var x,y,code : integer;
begin
  x:=gameAlign[gameType,1] + (cursorX-1)*12;
  y:=scrCoord[12+gameType,4]-scrCoord[12+gameType,2]+gameAlign[gameType,2]+1 + (cursorY-1)*12;
  
  if (flagMap[cursorX,cursorY]=true) then
    code:=12
  else
  begin
    if (clickMap[cursorX,cursorY]=false) then
      code:=9
    else
      code:=mineMap[cursorX,cursorY];
  end;
  Copy(scrCoord[code,1],scrCoord[code,2],
       scrCoord[code,3],scrCoord[code,4],
       1,
       x,y,
       0);
end;

procedure drawCursor(i, j : integer);
var offsetX,offsetY,x,y : integer;
begin                                                                              
  offsetX:=gameAlign[gameType,1];
  offsetY:=scrCoord[12+gameType,4]-scrCoord[12+gameType,2]+gameAlign[gameType,2]+1;
  offsetX:=gameAlign[gameType,1];
  { Draw rectangle }
  x:=offsetX+(i-1)*12;
  y:=offsetY+(j-1)*12;
  line_b(x,y,x+11,y+11,6,0);
  { Erase old rectangle }             
  if not((cursorX=i) and (cursorY=j)) then
    recoverObject;
  cursorX:=i;
  cursorY:=j;
end;

procedure changeFlag;
begin
  if (clickMap[cursorX,cursorY]=true) then
    exit;
    
  if flagMap[cursorX,cursorY]= false then
  begin
    if (flags=0) then
      exit;
    flagMap[cursorX,cursorY]:=true;
    flags:=flags-1;
  end
  else
  begin
    flagMap[cursorX,cursorY]:=false;
    flags:=flags+1;           
  end;
  recoverObject;
  drawCursor(cursorX,cursorY);  
end;  

procedure openMine;
var x,y: integer;
begin
  if (flagMap[cursorX,cursorY]=true) or (clickMap[cursorX,cursorY]=true) then
    exit;
  flood_fill(cursorX,cursorY);
  { Check for result } 
  x:=gameAlign[gameType,1]+scrCoord[15,1];
  y:=gameAlign[gameType,2]+1;
  if (gameType=2) then x:=x+48;
  { Clicked on a bomb }
  if (mineMap[cursorX,cursorY]=-1) then
  begin
    Copy(scrCoord[16,1],scrCoord[16,2],
       scrCoord[16,3],scrCoord[16,4],
       1,
       x,y,
       0);
    revealBombs;           	
    theEnd:=true;
  end;             
  { Opened all correct }
  if (winGame) then
  begin
    Copy(scrCoord[17,1],scrCoord[17,2],
       scrCoord[17,3],scrCoord[17,4],
       1,
       x,y,
       0);        	
    theEnd:=true;
    if isNewRecord(plytime,gameType) then
      rankDialog;
  end;
end;

procedure openNeighbors;
var i,j,count,nbombs : integer;
	oldX,oldY : integer;
begin
  nbombs:=mineMap[cursorX,cursorY];
  { Check if place is a number and if it is opened }
  if (clickMap[cursorX,cursorY]=false) or (nbombs<1) or (nbombs>8) then
    exit;
  { Check if correct # of flags surround number }
  count:=0;
  for i:=cursorX-1 to cursorX+1 do
  begin
    for j:=cursorY-1 to cursorY+1 do
    begin
      if (i>0) and (j>0) and (i<=width) and (j<=height) then {Inside table limits}
      begin
        if (flagMap[i,j]=true) then
          count:=count+1;
      end;
    end;    
  end;
  if count<>nbombs then
    exit;
   
  { Start to open! } 
  oldX:=cursorX;
  oldY:=cursorY;
  for cursorX:=oldX-1 to oldX+1 do
  begin
    for cursorY:=oldY-1 to oldY+1 do
    begin
      if (cursorX>0) and (cursorY>0) and (cursorX<=width) and (cursorY<=height) then {Inside table limits}
        openMine;
    end;    
  end;
  cursorX:=oldX;
  cursorY:=oldY;  
end;

procedure checkTime;
begin
  if timeStart=true then 
    exit;
  timeStart:=true;
  start_timer;
end;   

procedure gameControl;
var c : char;
	i,j : integer;
begin
    theEnd:=false;
    i:=1;
    j:=1; 
	while theEnd=false do
	begin
	  printLabels;
	  drawCursor(i,j);	  
	  if Keypressed then
	  begin	  
	    read(kbd,c);
	    if (ord(c)=122) or (ord(c)=120) then
	        checkTime;
	    case ord(c) of
        28: begin { Right }
              i:=i+1; if i > width then i:=width;
            end;
        29: begin { Left }
              i:=i-1; if i < 1 then i:=1;
            end;
        31: begin { Down }
              j:=j+1; if j > height then j:=height;
            end;
        30: begin { Up }
              j:=j-1; if j < 1 then j:=1;
            end;
        122: begin { z - Open mine }
               openMine;
             end;
        120: begin { x - Check / Uncheck flags }
               changeFlag;
             end;
        99: begin { c - Open neighborhood }
               openNeighbors;
             end;
        27 : exit;
        end;
	  end;
	end;
	readln;	
end;

procedure newGame;
begin
  	chooseGame(gameType);
	resetMap;
	createMap;	
	flags:=mines;
	cursorX:=1;
	cursorY:=1;
	timeStart:=false;
end;

procedure writeRanking;
var i : integer;
    w : string[10];
    xi, yi : integer;
begin
	xi:=200;
	yi:=50;
	
    Color(15,4,0);
    line_bf(xi,yi,xi+110,yi+120,4,0);
    line_b(xi,yi,xi+110,yi+120,15,0);
   
    Print(xi+5,yi+5,10,'Mines Super');
    
    for i:=1 to 10 do
    begin
      if (ranking[i].time<>-1) then
      begin
        Print(xi+5,yi+5+i*10,15,ranking[i].name);
        str(ranking[i].time,w);
        w:='000'+w;
 		w:=Copy(w,Length(w)-3,4);
        Print(xi+80,yi+5+i*10,15,w);
      end
      else
        Print(xi+5,yi+5+i*10,7,'Empty');
    end;
    readln;
end;

procedure menu;
var c : char;
    i,j : integer;
    xi, yi : integer;
begin
  c:='a';
                     
  xi:=220;
  yi:=80;
  while ord(c)<>255 do
  begin
    Color(15,4,0);
    line_bf(xi,yi,xi+75,yi+35,4,0);
    line_b(xi,yi,xi+75,yi+35,15,0);
    Print(xi+5,yi+5,15,'Mines Super');
    Print(xi+5,yi+15,15,'Records');
    Print(xi+5,yi+25,15,'Exit');    
    Copy(xi,yi,xi+75,yi+35,0,90,190,1);
    line_bf(xi+3,yi+3,xi+73,yi+13,7,2);
    
    i:=1;
    c:='a';
    while ord(c)<>13 do
    begin
      read(kbd,c);
      Copy(90,190,165,225,1,xi,yi,0);
      case ord(c) of      
      31 : begin
             i:=i+1;
             if (i>3) then i:=1;
           end;
      30 : begin
             i:=i-1;
             if (i<1) then i:=3;
           end;    
      end;
      line_bf(xi+3,yi+3+(i-1)*10,xi+73,yi+5+(i-1)*10+8,7,2);
    end;           
                
    { For debug }
    if i=4 then
    begin
      screen(0);
      printMap;
      readln;
      screen(7);
    end;
    

    if i=2 then
      writeRanking;
      
    if i=3 then
      exit;

    if i<2 then
    begin
      gameType:=i;
      newGame;
      Color(15,0,0);
      cls2;
      Color(6,14,0);
      mountTable;
      gameControl;
    end;
  end;
end;

begin
  plyName:='';
  recordChanged:=false;
  loadScreen;
  initRanking;
  menu;     
  color(15,0,0);
  screen(0);
  if (recordChanged) then
    saveRanking;
  writeln('MarMSX 2007');
end.